#include "/usr/include/fftw3.h"
#include "FFTHandler.h"
#include <iostream>
#include <math.h>

FFTHandler::FFTHandler(int N) {
    in_fft = (double *) malloc(sizeof(double)*N);
    out_fft = (double*) malloc(sizeof(double)*N);
    points = N;
}

double *FFTHandler::computeFFT(short *data){
    populate(data);
    p = fftw_plan_r2r_1d(points, in_fft, out_fft, FFTW_REDFT10 , FFTW_ESTIMATE);
    fftw_execute(p);
    fftw_destroy_plan(p);

    for(int i = 0; i < points; i++)
        out_fft[i] = abs(out_fft[i]);

    return out_fft;
}

void FFTHandler::populate(short *data){
    for(int i = 0; i < points; i++){
        in_fft[i] = data[i];
    }
}

void FFTHandler::changeFFTPoints(int points){

    // We use realloc to reallocate the previous and contiguous
    // memory usage of the fft

    //this->points = points;
    //in_fft = (double *) realloc(in_fft, points);
    //out_fft = (double *) realloc(in_fft, points);

}

int FFTHandler::getPoints(){
    return points;
}

QVector <double> * FFTHandler::getPeaks(double *arr, int size, int threshold){
    double diff = 0;
    peaks.clear();

    for(int i = 0; i < size-1; i++){
        diff = abs(arr[i+2]) + abs(arr[i]) - 2*abs(arr[i+1]);
        if(diff>threshold)
            peaks.append(i);
    }
    return &peaks;

}
