
#ifndef MICMANAGER_H
#define MICMANAGER_H
#include <string.h>
#include <iostream>
#include "/usr/include/alsa/asoundlib.h"


class MicManager {
    
    public:
        MicManager(short bufferSizeMatrix, int totalBufferSize, long int sampleFreq);
        void readBuffer();
        void closeDev();
        void populateTotalBuffer();
        void setBufferSize(int size);
        void setTotalBufferSize(int size);
        void setSampleRate(long int sr);
        void openDev();
        void setDev(int sr);

        short *getBuffer();
        short *getTotalBuffer();
        short getMaxima(double *t);



    private:

        int index = 0;
        int err_code;
        int buffer_size;
        int total_buffer_size;
        long int sample_rate;

        short *buffer;
        short *total_buffer;

        const char *device = "default";
        snd_pcm_t *handle_capture;
        snd_pcm_sframes_t frames;

};

#endif /* MICMANAGER_H */

