#include "notemanager.h"

NoteManager::NoteManager()
{
   generateFreqTable();
}

void NoteManager::generateFreqTable(){
    freq_table = (double *) malloc(sizeof(double)*107);
    for(int i = 21; i < 127; i++)
        freq_table[i-21] = 13.75*pow(2, (i-9.0)/12.0);
}

std::string NoteManager::getNearNote(double freq){
    short nearFreq = getNearFreqPosition(freq);
    return american_notes[nearFreq%12];
}

int NoteManager::getCentPitch(double freq){
    short nearFreq = getNearFreqPosition(freq);
    return 1200*log(freq/freq_table[nearFreq])/log(2);
}

short NoteManager::getNearFreqPosition(double freq){

    double delta;
    double min = 1000000;
    short near = -1;
    for(int i = 0; i < 107; i++){
        delta = freq_table[i]-freq;

        if(abs(delta) < min){
            min = abs(delta);
            near++;
        }

    }

    return near;
}
